/**************************************************************************
***    
*** Copyright (c) 1995-2000 Regents of the University of California,
***               Andrew E. Caldwell, Andrew B. Kahng and Igor L. Markov
***
***  Contact author(s): abk@cs.ucla.edu, imarkov@cs.ucla.edu
***  Affiliation:   UCLA, Computer Science Department,
***                 Los Angeles, CA 90095-1596 USA
***
***  Permission is hereby granted, free of charge, to any person obtaining 
***  a copy of this software and associated documentation files (the
***  "Software"), to deal in the Software without restriction, including
***  without limitation 
***  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
***  and/or sell copies of the Software, and to permit persons to whom the 
***  Software is furnished to do so, subject to the following conditions:
***
***  The above copyright notice and this permission notice shall be included
***  in all copies or substantial portions of the Software.
***
*** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
*** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*** CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
*** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
*** THE USE OR OTHER DEALINGS IN THE SOFTWARE.
***
***
***************************************************************************/




//! author="970926 by Igor Markov"

#ifndef _RANCOR_H_
#define _RANCOR_H_

#include <vector>

class RankCorrelation;
typedef RankCorrelation RankCorr;

//: Computes the rank correlation between two vectors of data.
class RankCorrelation
{
public:
   class RankCorrElem
   {
   public:
      double x;
      double y;
      RankCorrElem() {};
      RankCorrElem(double xx, double yy):x(xx),y(yy) {}
   };

private:
   double _rankcorr;
   void compute_rankcorr(std::vector<RankCorrElem>& data);

public:

   RankCorrelation(const std::vector<double>& x1, const std::vector<double>& x2);
   RankCorrelation(const std::vector<unsigned>& x1, const std::vector<unsigned>& x2);

   operator double() const { return _rankcorr; }
};

#endif
